import c4d
from c4d import documents
import math

#Welcome to the world of Python


def main():
    for objs in doc.GetSelection():
        oname = objs.GetName()
        pos = objs.GetAbsPos()
        pos_x = pos[0]
        pos_y = -pos[2]
        pos_z = pos[1]
        pos_x_str = str(pos_x)
        pos_y_str = str(pos_y)
        pos_z_str = str(pos_z)
        
        scale = objs.GetAbsScale()
        scale_x = scale[0]
        scale_y = scale[2]
        scale_z = scale[1]
        scale_x_str = str(scale_x)
        scale_y_str = str(scale_y)
        scale_z_str = str(scale_z)
        
        rot = objs.GetAbsRot()
        rot_p = math.degrees(-rot[2])
        rot_y = math.degrees(-rot[0])
        rot_r = math.degrees(rot[1])
        rot_p_str = str(rot_p)
        rot_y_str = str(rot_y)
        rot_r_str = str(rot_r)
        copy_tx = "      Begin Actor Class=StaticMeshActor Name=" + oname + " Archetype=StaticMeshActor\'/Script/Engine.Default__StaticMeshActor\'\n         Begin Object Class=StaticMeshComponent Name=StaticMeshComponent0 ObjName=StaticMeshComponent0 Archetype=StaticMeshComponent\'/Script/Engine.Default__StaticMeshActor:StaticMeshComponent0\n         End Object\n         Begin Object Name=StaticMeshComponent0\n            StaticMesh=StaticMesh\'/Engine/EditorMeshes/EditorCube.EditorCube\'\n            RelativeLocation=(X=" + pos_x_str + ",Y=" + pos_y_str + ",Z=" + pos_z_str + ")\n            RelativeScale3D=(X=" + scale_x_str + ",Y=" + scale_y_str + ",Z=" + scale_z_str + ")\n            RelativeRotation=(Pitch=" + rot_p_str + ",Yaw=" + rot_y_str + ",Roll=" + rot_r_str + ")\n            CustomProperties \n         End Object\n         StaticMeshComponent=StaticMeshComponent0\n         Components(0)=StaticMeshComponent0\n         RootComponent=StaticMeshComponent0\n         ActorLabel=\"" + oname + "\"\n      End Actor"
        to_ue4 = "Begin Map\n   Begin Level\n" + copy_tx + "   End Level\nBegin Surface\nEnd Surface\nEnd Map"
        print to_ue4
        
    c4d.EventAdd()

if __name__=='__main__':
    main()
